import { ElementRef, OnInit, AfterViewInit, EventEmitter } from '@angular/core';
import { HZDatePickerService } from './hz-date-picker.service';
export interface DPConfig {
    btnClasses?: string;
    navBtnClasses?: string;
    showDays?: boolean;
    dayFormat?: string;
    selectedItemClass?: string;
    selectedDateFormat?: string;
}
export declare class HZDatePickerComponent implements OnInit, AfterViewInit {
    private dpService;
    hzDatePicker: ElementRef;
    dpConfig: DPConfig;
    onDateChange: EventEmitter<Date>;
    viewLoaded: boolean;
    dayFormat: string;
    isCallInProgress: boolean;
    daysOfMonth: Array<any>;
    selectedDate: Date;
    private MONTH_NAVS;
    private validDayFormats;
    constructor(dpService: HZDatePickerService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    /**
     * @author Ahsan Ayaz
     * Sets the inital config properties to be used by the datepicker template
     */
    setDefaultConfigValues(): void;
    /**
     * @author Ahsan Ayaz
     * This function is triggered when a date is clicked from the dates list
     * @param dayBtn
     */
    onDateClick(dayBtn: any): void;
    /**
     * @author Ahsan Ayaz
     * This function updates the buttons to display using the current date
     * @param date
     */
    updateDateBtns(date?: Date): void;
    /**
     * @author Ahsan Ayaz
     * This function is triggered when the user clicks on any of the next month nav button or previous month nav button
     * Fetches the next month's buttons from service and updates the buttons on view.
     * Also sets the same date of the next month as selected date
     * @param target
     */
    onMonthNavClick(target: string): void;
}
