import { OnInit } from '@angular/core';
export declare class HZDatePickerService implements OnInit {
    constructor();
    ngOnInit(): void;
    /**
     * @author Ahsan Ayaz
     * This function returns an array of custom objects representing days information in the given month
     * @param dateObj{Date}
     * @returns {Array}
     */
    getDaysOfMonth(dateObj?: Date): Array<any>;
    /**
     * @author Ahsan Ayaz
     * Returns if the dateObject passed is an actual Date
     * @param dateObj {Date}
     * @returns {boolean} istDate value
     */
    isDate(dateObj: Date): boolean;
    /**
     * @author Ahsan Ayaz
     * Calculates the no of days in the given date or using given year and month
     * @param dateObj {Date}
     * @param year {number}
     * @param month {number}
     * @returns no of days {number}
     */
    daysInMonth(dateObj: Date, year?: number, month?: number): number;
    /**
     * @author Ahsan Ayaz
     * Calculates the no of weeks in the given date (month)
     * @param dateObj {Date}
     * @returns number of days {number}
     */
    weeksInMonth(dateObj: Date): number;
}
