"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var HZDatePickerService = (function () {
    function HZDatePickerService() {
    }
    HZDatePickerService.prototype.ngOnInit = function () {
    };
    /**
     * @author Ahsan Ayaz
     * This function returns an array of custom objects representing days information in the given month
     * @param dateObj{Date}
     * @returns {Array}
     */
    HZDatePickerService.prototype.getDaysOfMonth = function (dateObj) {
        if (dateObj === void 0) { dateObj = new Date(); }
        var days = [];
        var noOfDays = this.daysInMonth(dateObj);
        for (var i = 1, len = noOfDays; i <= len; i++) {
            var text = i.toString();
            // grab current date and check passed arguments.
            var date = void 0, month = void 0, year = void 0;
            date = i; //setting the date here
            if (!month || month === undefined) {
                month = dateObj.getMonth();
            }
            if (!year || year === undefined) {
                year = dateObj.getFullYear();
            }
            var currDate = new Date(year, month, date);
            days.push({
                text: text,
                date: currDate,
                isWeekend: (currDate.getDay() == 6 || currDate.getDay() == 0),
                isSelected: dateObj.getDate() == i
            });
        }
        return days;
    };
    /**
     * @author Ahsan Ayaz
     * Returns if the dateObject passed is an actual Date
     * @param dateObj {Date}
     * @returns {boolean} istDate value
     */
    HZDatePickerService.prototype.isDate = function (dateObj) {
        var date = dateObj ? new Date(dateObj.toString()) : null;
        return (date !== null) && !isNaN(date) && (date.getDate() !== undefined);
    };
    /**
     * @author Ahsan Ayaz
     * Calculates the no of days in the given date or using given year and month
     * @param dateObj {Date}
     * @param year {number}
     * @param month {number}
     * @returns no of days {number}
     */
    HZDatePickerService.prototype.daysInMonth = function (dateObj, year, month) {
        year = dateObj ? dateObj.getFullYear() : year;
        month = dateObj ? dateObj.getMonth() : month;
        var startDate = new Date(year, month, 1), endDate = new Date(year, month + 1, 1);
        var calc = (endDate - startDate) / (1000 * 60 * 60 * 24);
        return parseInt(calc, 10);
    };
    /**
     * @author Ahsan Ayaz
     * Calculates the no of weeks in the given date (month)
     * @param dateObj {Date}
     * @returns number of days {number}
     */
    HZDatePickerService.prototype.weeksInMonth = function (dateObj) {
        var year = dateObj.getFullYear();
        var month = dateObj.getMonth();
        var firstOfMonth = new Date(year, month - 1, 1), lastOfMonth = new Date(year, month, 0), used = firstOfMonth.getDay() + lastOfMonth.getDate();
        return Math.ceil(used / 7);
    };
    return HZDatePickerService;
}());
HZDatePickerService = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [])
], HZDatePickerService);
exports.HZDatePickerService = HZDatePickerService;
//# sourceMappingURL=hz-date-picker.service.js.map